//
// Map Mod 
// by Jeremy Mappus - Jerm a.k.a DarkTheties
//
// This mod will load a file called maps.txt in the baseq2 directory. It will take any names
// seperated by white spaces and list them as seperate name entries into the map_mod_names_ 
// table. It also provides a function for checking the change level. 
//

#include "g_local.h"
#include "g_map_mod.h"
#include <io.h>
#include <FCNTL.H>

int  map_mod_ = 0;
int  map_mod_current_level_ = -1;
int  map_mod_n_levels_ = 0;
char map_mod_names_[50][100];

//
//
long get_file_size(int file)
{
	return _filelength(file);
}

//
//
char *malloc_file_size(long file_size)
{
	char *p_buffer = malloc(file_size);
	memset(p_buffer,0,file_size);
	return p_buffer;
}

//
//
void map_mod_set_up()
{
	int file = _open(".\\baseq2\\maps.txt",_O_RDONLY | _O_TEXT);
	map_mod_ = 0;
	map_mod_current_level_ = -1;
	map_mod_n_levels_ = 0;
	if (file != -1)
	{
		long file_size = get_file_size(file);
		char *p_buffer = malloc_file_size(file_size);

		int blah = _read(file, (void *)p_buffer, file_size);

		char *p_name = p_buffer;
		long counter = 0;
		int n_chars = 0;
		do
		{
			while (*p_name != ' ' && *p_name != '\r' && *p_name != '\n' && counter < file_size)
			{
				n_chars++;
				counter++;
				p_name++;
			}
			if (n_chars)
			{
				memcpy(&map_mod_names_[map_mod_n_levels_][0], p_name - n_chars, n_chars);
				memset(&map_mod_names_[map_mod_n_levels_][n_chars], 0, 1);
				map_mod_n_levels_++;
				n_chars = 0;
			}
			counter++;
			p_name++;

		} while (counter < file_size);

		free(p_buffer);
		_close(file);

		if (map_mod_n_levels_)
		{
			map_mod_ = true;
		}
	}
}


//
//
char* map_mod_next_map()
{
	map_mod_current_level_++;
	if (map_mod_current_level_ == map_mod_n_levels_)
	{
		map_mod_current_level_ = 0;
	}

	return map_mod_names_[map_mod_current_level_];
}

